<?php 
/**
 * Plugin Name: Vip Detector (Matomo Plugin)
 * Plugin URI: http://plugins.matomo.org/VipDetector
 * Description: Detect visits from special predefined IP ranges and display the name
 * Author: Sebastian Elisa Pfeifer
 * Author URI: https://github.com/deadda7a/Matomo-VIP-Detector
 * Version: 1.0.0
 */
?><?php
namespace Piwik\Plugins\VipDetector;

use Piwik\DbHelper;
use Piwik\Db;
use Piwik\Common;

 
if (defined( 'ABSPATH')
&& function_exists('add_action')) {
    $path = '/matomo/app/core/Plugin.php';
    if (defined('WP_PLUGIN_DIR') && WP_PLUGIN_DIR && file_exists(WP_PLUGIN_DIR . $path)) {
        require_once WP_PLUGIN_DIR . $path;
    } elseif (defined('WPMU_PLUGIN_DIR') && WPMU_PLUGIN_DIR && file_exists(WPMU_PLUGIN_DIR . $path)) {
        require_once WPMU_PLUGIN_DIR . $path;
    } else {
        return;
    }
    add_action('plugins_loaded', function () {
        if (function_exists('matomo_add_plugin')) {
            matomo_add_plugin(__DIR__, __FILE__, true);
        }
    });
}

class VipDetector extends \Piwik\Plugin {
    public function registerEvents() {
        return [
            'CronArchive.getArchivingAPIMethodForPlugin' => 'getArchivingAPIMethodForPlugin',
        ];
    }

    // support archiving just this plugin via core:archive
    public function getArchivingAPIMethodForPlugin(&$method, $plugin) {
        if ($plugin == 'VipDetector') {
            $method = 'VipDetector.getExampleArchivedMetric';
        }
    }

    public function activate() {
        DbHelper::createTable(
            'vip_detector_names',
            'id INT NOT NULL AUTO_INCREMENT, name VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL, PRIMARY KEY (id)'
        );
        DbHelper::createTable(
            'vip_detector_ranges',
            'id INT NOT NULL AUTO_INCREMENT, type TINYINT NOT NULL, range_from VARBINARY(16) NOT NULL, range_to VARBINARY(16) NOT NULL, name_id INT NOT NULL, PRIMARY KEY (id)'
        );
    }

    public function uninstall() {
        Db::dropTables(
            array(
                Common::prefixTable('vip_detector_names'),
                Common::prefixTable('vip_detector_ranges')
            )
        );
    }
}
